"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractApplicationDataSource = void 0;
const typeorm_1 = require("typeorm");
class AbstractApplicationDataSource {
    constructor() {
        this.connected = false;
    }
    async initialize(options) {
        this.dataSource = new typeorm_1.DataSource(options);
        await this.dataSource.initialize();
        this.connected = true;
        this.initializeRepositories();
    }
    async teardown() {
        if (!this.dataSource?.isInitialized)
            throw new Error('Data Source has not been initialized!');
        await this.dataSource.destroy();
        this.connected = false;
    }
    getRepository(target) {
        if (!this.dataSource?.isInitialized)
            throw new Error('Data Source has not been initialized!');
        return this.dataSource.getRepository(target);
    }
}
exports.AbstractApplicationDataSource = AbstractApplicationDataSource;
//# sourceMappingURL=abstractDataSource.js.map