import { DataSource } from 'typeorm';
export class AbstractApplicationDataSource {
    constructor() {
        this.connected = false;
    }
    async initialize(options) {
        this.dataSource = new DataSource(options);
        await this.dataSource.initialize();
        this.connected = true;
        this.initializeRepositories();
    }
    async teardown() {
        if (!this.dataSource?.isInitialized)
            throw new Error('Data Source has not been initialized!');
        await this.dataSource.destroy();
        this.connected = false;
    }
    getRepository(target) {
        if (!this.dataSource?.isInitialized)
            throw new Error('Data Source has not been initialized!');
        return this.dataSource.getRepository(target);
    }
}
//# sourceMappingURL=abstractDataSource.js.map